CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

OBJ

  ctr   : "jitter-free_clocks"
  pst   : "Parallax Serial Terminal"

PUB  start | i, freq

 pst.Start(115200)

 ' i := 0
  repeat i from 0 to 10 step 2                             
    ctr.start(i, i, i + 12 )              ' set up 6 cogs each with 2 counters (ctra & ctrb)
                                          ' cog 1-6 ctra: APIN = {0, 2, 4, 6, 8, 10}, BPIN = {1, 3, 5, 7, 9, 11}
                                          ' cog 1-6 ctrb: APIN = { 12, 14, 16, 18, 20, 22}, BPIN = {13, 15, 17, 19, 21, 23}
    ctr.set_period(i, 200 , 200 )         ' set the period for each ctra module
    ctr.set_period(i + 1, 150 , 150 )     ' set the period for each ctrb module

waitcnt(clkfreq * 3 + cnt)

' Manual input to change counters    
repeat
  pst.Str(String("Select counter APIN number (0-22):"))
  i := pst.DecIn
   if ((i // 2) <> 0)  OR (i > 22)
    pst.Str(String($0D, " Must be even pin between 0 and 22.", $0D))
    next
  pst.Dec(i)
  pst.Char(pst#NL)
  pst.Str(String("Input period in clock cycles (133-1000):" ))
  freq := pst.DecIn
  freq #>= 133
  freq <#= 1000
  pst.Dec(freq)
  pst.Char(pst#NL)
  case i 
     0, 2, 4, 6, 8, 10:
      ctr.set_period(i, freq, freq)
     12, 14, 16, 18, 20, 22:
      ctr.set_period( i - 11, freq, freq) 
 pst.CharIn
 pst.Char(pst#CS)     


{  repeat freq from 135 to 200
    ctr.set_period(0, freq, freq)
    ctr.set_period(1, freq, freq)
    waitcnt(clkfreq / 150 + cnt )
  repeat freq from 200 to 135
    ctr.set_period(0, freq, freq)
    ctr.set_period(1, freq, freq)
    waitcnt(clkfreq / 150 + cnt )
    }